<?php
// myDBR defaults
// DO NOT CHANGE THIS FILE
// If you want to change the default values, override them in /user/defaults.php as this file will be overridden in updates
//

$mydbr_defaults = [
  'chart' => [
    'sizeX' => 600,
    'sizeY' => 350,
    'size_mobile' => ['x' => 430, 'y' => 270],
    'title_color' => 0x00000000, // ImageChart only, ARGB Color 
    'title_font' => 'arialbd.ttf', // ImageChart
    'font' => null, // Set this to override chart font
    'font_size' => null, // Set this to override chart font sizes
    'title_font_size' => 11, // ImageChart 
    'x_axis_font_color' => 0x00666666, // ImageChart only, ARGB Color 
    'x2_axis_font_color' => 0x00666666, // ImageChart only, ARGB Color 
    'y_axis_font_color' => 0x00666666, // ImageChart only, ARGB Color 
    'y2_axis_font_color' => 0x00666666, // ImageChart only, ARGB Color 
    'z_axis_font_color' => 0x00666666, // ImageChart only, ARGB Color 
    'x_axis_color' => 0xB2C5D8, // ImageChart only, ARGB Color 
    'x2_axis_color' => 0xB2C5D8, // ImageChart only, ARGB Color 
    'y_axis_color' => 0xFFFF0000, // ImageChart only, ARGB Color 
    'z_axis_color' => 0xB2C5D8, // ImageChart only, ARGB Color 
    'axis_font' => 'arial.ttf', // ImageChart 
    'axis_font_size' => 9, // ImageChart 
    'axis_label_font' => 'arialbd.ttf', // ImageChart 
    'axis_label_font_size' => 9, // ImageChart 
    'axis_label_font_color' => 0x00666666, // ImageChart 
    'label_color' => 0x00666666, // ImageChart only, ARGB Color 
    'label_data_font_color' => 0xFFFFFF, // ImageChart only, ARGB Color 
    'label_font' => 'arial.ttf', // ImageChart 
    'label_font_size' => 9, // ImageChart 
    'label_font_color' => 0x00666666,
    'legend_default_position' => 'right',
    'legend_default_style' => [
      'background_color' => 0xFFFFFFFF,
      'edge_color' => NULL,
      'rounded_border' => [
        'TL' => 5,
        'TR' => 5,
        'BL' => 5,
        'BR' => 5
      ]
    ],
    'chart_extra_width_with_legend_on_side' => 100,
    'legend_color' => 0x00666666, // ImageChart only, ARGB Color 
    'legend_font' => 'arial.ttf', // ImageChart 
    'legend_font_size' => 9, // ImageChart 
    'legend_font_color' => 9, // ImageChart 
    'background_color' => 0xFFFFFFFF, // 0x00FFFFFF,
    'edge_color' => 0xFF000000,
    'plot_edge_color' => 0xFFFF0000,
    'raised_effect' => 0,
    'padding_top' => 0,
    'grid_color_horizontal' => 0xD7D7D7,
    'grid_color_vertical' => 0xFF000000,
    'colors' => [
      0x3F90F4,
      0x5AB231,
      0xF7D921,
      0xF43011,
      0xA05AE5,
      0xF984A1,
      0xDDE10A,
      0xAEAEAE,
      0xAFD8F8,
      0xFEB56A,
      0x91E8E1,
      0xFF66CC,
      0x669966,
      0x7C7CB4,
      0xFF9933,
      0x9900FF,
      0x99FFCC,
      0xCCCCFF,
      0x669900,
      0x1941A5,
    ],
    'bargap' => ['col' => 0.2, 'mscol' => 0.5],
    'subbargap' => -1.69e-100, /* TouchBar */
    'alternate_color' => ['0xFFFFFF', '0xFFFFFF'],
    'polar_radar' => ['xSize' => 500, 'grid_color' => [0x80000000, 1, 0xc0000000, 1]],
    'radar' => ['grid_color' => [0xDBDBDB, 1, 0xDBDBDB, 1]],
    'line' => [
      'x_axis_tick_middle' => 1,
      'x_axis_margin' => 20,
    ],
    'meter' => [
      'size' => 240,
      'inner' => 0xF4F4F4,
      'outer' => 0x736F6E,
      'outer2' => 0xD5D5D5,
      'green' => 0x6666ff66,
      'yellow' => 0x66ffff33,
      'red' => 0x66ff6666,
      'title' => ['font' => 'arialbd.ttf'],
      'text' => ['font' => 'ariali.ttf', 'size' => 8, 'color' => 0x000000],
      'label' => ['font' => 'ariali.ttf', 'size' => 8, 'color' => 0x000000],
      'pointer' => ['color' => 0x20B82313],
      'color' => [
        'type' => 'gradient',
        'gradient' => [
          [0, 0x6666ff],
          [25, 0x00bbbb],
          [50, 0x00ff00],
          [75, 0xffff00],
          [100, 0xff0000],
        ],
        'step' => [
          [0, null],
          [33, 0x6666ff66],
          [66, 0x66ffff33],
          [100, 0x66ff6666],
        ],
      ],
      'zones' => [
        [0, 33, 0x4000FF00],
        [33, 66, 0x40FFFF00],
        [66, 100, 0x40FF0000],
      ],
      'theme' => [
        'black' => [
          'background' => 0x000000,
          'label-color' => 0xffffff,
          'border' => 0x888888,
          'ring1' => 0x707070, // Meter chart ring second to outer
          'ring2' => 0xA0A0A0, // Meter chart outer ring
          'ring3' => 0x222222, // inner for second ring
          'title-color' => 0x000000,
          'text-color' => 0xffffff,
          'tick-color' => 0xffffff,
          'pointer-color' => 0x20B82313,
          'linearmeter-pointer-color' => 0xAAAAAA,
          'rectangular-border' => 0x9fcccccc,
          'rectangular-bottom' => 0x9f777777,
          'glare' => ['meter', 'semicircle', 'rectangularmeter'],
          'tick-width' => ['major' => 2, 'minor' => 1, 'micro' => 1],
          'label-font-size' => null, // Dynamic
          'cap2' => null,
        ],
        'white' => [
          'background' => 0xffffff,
          'label-color' => 0x444444,
          'border' => 0xffffff,
          'ring1' => 0xD5D5D5,
          'ring2' => 0xA0A0A0, //0x736F6E
          'ring3' => 0xCCCCCC, // inner for second ring
          'title-color' => 0x000000,
          'text-color' => 0x000000,
          'tick-color' => 0x000000,
          'pointer-color' => 0x20B82313,
          'linearmeter-pointer-color' => 0x808080,
          'rectangular-border' => 0x9fcccccc,
          'rectangular-bottom' => 0x9fcccccc,
          'glare' => [],
          'tick-width' => ['major' => 2, 'minor' => 1, 'micro' => 1],
          'label-font-size' => null, // Dynamic
          'cap2' => null,
        ],
        'default' => [
          'background' => 0xeeeeee,
          'label-color' => 0x000000,
          'border' => 0xcccccc,
          'ring1' => 0xD5D5D5,
          'ring2' => 0x736F6E,
          'ring3' => 0xCCCCCC, // inner for second ring
          'title-color' => 0x000000,
          'text-color' => 0x000000,
          'tick-color' => 0x000000,
          'pointer-color' => 0x20B82313,
          'linearmeter-pointer-color' => 0x808080,
          'rectangular-border' => 0x9fcccccc,
          'rectangular-bottom' => 0x9fcccccc,
          'glare' => [],
          'tick-width' => ['major' => 2, 'minor' => 1, 'micro' => 1],
          'label-font-size' => null, // Dynamic
          'cap2' => null,
        ],
      ],
    ],
    'semicircle' => ['size' => 350],
    'rectangularmeter' => [
      'size' => 350,
      'background' => null,
      'border' => 0x888888,
    ],
    'squaremeter' => [
      'orientation' => 'left-bottom'
    ],
    'donutpercent' => [
      'size' => 250,
      'color2' => 0xefefef,
      'font' => [
        'name' => 'arial.ttf',
        'color' => 0x444444,
      ],
      'orientation' => 1,
      'scale' => 6.25
    ],
    'semidonutpercent' => [
      'size' => 250,
      'colors' => ['end' => 0xf2f2f2, 'separator' => 0xFFFFFF], /* End color, Separator color */
      'font' => [
        'name' => 'arial.ttf',
        'color' => 0x444444,
      ],
      'orientation' => 1,
      'scale' => 3.33333
    ],
    'donut' => [
      'font' => [
        'name' => 'arial.ttf',
        'color' => 0x444444,
      ],
      'orientation' => 1,
      'scale' => 3.33333
    ],
    'softlightning' => true, // For column and bar charts toggles the softlightning effect  
    /*
    BottomLeft = 1
    BottomCenter = 2
    BottomRight = 3
    Left = 4
    Center = 5
    Right = 6
    TopLeft = 7
    TopCenter = 8
    TopRight = 9
    Top = TopCenter
    Bottom = BottomCenter
    TopLeft2 = 10
    TopRight2 = 11
    BottomLeft2 = 12
    BottomRight2 = 13
    */
    'softlightning_direction' => [
      'column' => 4, // Left
      'column3d' => 4,
      'bar' => 8, // TopCenter
      'stackedbar' => 8,
      'stackedcolumn' => 4,
      'bar3d' => 8,
      'stackedbar3d' => 8,
      'stackedcolumn3d' => 4,
      'msbar' => 8,
      'mscolumn' => 4,
      'mscolumn3d' => 4,
      'percentbar' => 8,
      'percentcolumn' => 4,
    ],
    'always_use_link_menu' => false, // Whether single linked report shows menu or follows link 
    'default_marker' => 16, // GlassSphere2Shape
    'marker_size' => 10, // Marker size for scatter chart
    'marker_edge' => -1, // Marker edge color (-1=linecolor)
    'autoscale' => ['top' => 0.1, 'bottom' => 0.1, 'zeroaffinity' => 0.5],
    'embed_image' => false,
    'pie_label_format' => '$c->setLabelLayout("SideLayout",-1, 10);$c->setLabelStyle()->setBackground(Transparent, -1, 0);',
    'line_width' => 3,
    'width_per_item' => 110,
    'width_extra' => 80,
    'height_per_item' => 60,
    'height_extra' => 55,
    'gantt' => [
      'baseline_pattern' => ['color' => 0xe0e0e0, 'border' => 0x808080, 'height' => 8],
      'baseline_text' => 'Baseline',
      'start_of_month_format' => '<*font=arialbd.ttf*>{value|mmm d}',
      'start_of_day_format' => '-{value|d}',
      'start_of_hour_format' => '-{value|hh}',
      'scale' => 7,
      'single_label' => 0
    ],
    'meters' => [
      'font' => 'ariali.ttf',
    ],
    'linearmeter' => [
      'size' => [300, 60],
      'height' => 20,
      'label' => ['font' => 'arial.ttf', 'size' => 8, 'color' => 0x00000000],
      'text' => ['font' => 'arial.ttf', 'size' => 8, 'color' => 0x00000000],
      'pointer' => ['color' => 0x808080],
      'type' => 'gradient',
      'zones' => [
        ['from' => 0, 'to' => 33, 'color' => 0x4000FF00],
        ['from' => 33, 'to' => 66, 'color' => 0x40FFFF00],
        ['from' => 66, 'to' => 100, 'color' => 0x40FF0000],
      ]
    ],
    'fix_y_axis' => ['yaxis_margin_right' => 8],
    'boxwhisker' => ['fill_color' => 0x3F90F4, 'whisker_color' => 0x3644CC, 'edge_color' => 0xCCCCCC],
    'floatingbox' => ['edge_color' => 0x444444],
    'skip_null_values' => true,
    'radar_transparency' => 30,
    'bubble' => ['transparency' => 10, 'edge_color' => 0xCCCCCC],
    'fix_apple_browser_gradient_svg_bug' => 'png', // png = use png instead, step = use step, none = bug fixed
    'session_cache_clear' => 180, // How long the chart is kept in session in seconds
    'target' => [
      'width' => 2,
      'gap' => 0.1
    ],
    'area' => [
      'line' => [
        'color' => null,
        'width' => 2
      ],
      'opacity' => 50, // Percentage
    ],
    'scatter3d' => [
      'view_angle' => [[30, 45]],
      'wall_color' => [['0xF8F8F8', '0xF8F8F8', '0xF8F8F8', '0x888888']],
      'drop_line_color' => '0x888888'
    ],
    'preferred_type' => null /* Possible value chartdirector, chartjs */
  ],
  'pager' => 20, // Default pager page size in rows 
  'automatic_parameters' => [
    'username' => 'inLogin', // Automatic report parameter containing the username 
    'ip_address' => 'inIPAddress', // Users IP address
    'locale' => 'inLocale', // locale used in reports
    'user_agent' => 'inUseragent', // locale used in reports
    'autoexecute' => 'inAutoexecute', // Automatically executes the report if parameters are ok
    'accept_language' => 'inHTTP_ACCEPT_LANGUAGE', // HTTP_ACCEPT_LANGUAGE
    'referer' => 'inHTTP_REFERER', // HTTP_REFERER
    'export_format' => 'inExportFormat', // export=sql
    'report_url' => 'inAutoReportURL', // Report URL
    'report_procedure' => 'inAutoReportProcedure', // Report URL
    'theme' => 'inAutoTheme',
    'session_id' => 'inSessionIDHash',
    'import_filename' => 'inImportFilename',
    'import_total_rows' => 'inImportTotalRows',
    'import_errors' => 'inImportErrors',
    'version_build' => 'inVersionBuild',
    'ui_mode' => 'inAutoUIMode',
    'replica' => 'inAutoReplica', // Chosen replica
    'mydbr_login_organization_id' => 'in_MyDBR_OrganizationID', // optional extra SSO parameters
    'use_POST' => 'inAutoUsePOST', // Use POST in form
    // 'sso_extra1' => 'in_SSO_OrganizationID', // optional extra SSO parameters
  ],
  'magic_parameters' => [
    'export' => 'inExportFormatSet'
  ],
  'organization' => [
    'external_id_automatic_parameter' => 'in_SSO_OrganizationID'
  ],
  'automatic_parameter_defaults' => [], // Define extra-parameter values for local users, allows simulating sso_exrta
  'automatic_parameter_not_for_admin' => [], // Define automatic-parameters which are not automatic-parameters for admin
  'parameters' => [
    'name_suffix' => ':',
    'empty_numeric_results_null' => false,
    'empty_string_results_null' => false,
    'max_sso_extra_parameters' => 5,
    'allow_post_parameters' => true,
    'daterange_optional' => false,
    'GET_param_query' => true,
    'clean_tags_from_user_input' => 'htmLawed', /* Possible value strip_tags, htmLawed */
    'clean_tags_from_user_input_htmLawed' => ['safe' => 1],
    'limit_width' => true
  ],
  'xss' => [
    'htmLawed_options' => ['safe' => 1]
  ],
  'missing_parameter_style' => 'color: red;',
  'password' => [
    'expiration' => 30,
    'length' => 8,
    'use_phpass' => false
  ],
  'autocomplete_max_rows' => 20,
  'header_logo_cell' => 'width: 90px; padding: 1px;',
  'category_colors' => ['00C322', 'FF7A00', 'D2006B', '0066CC', 'CC6600', 'A300C3', 'C30061', 'C38500'], // Report category default colors
  'search' => false, // Display search + export by default
  'user_prefs_formatting' => true, // Allow user to have own preferences
  'prefs' => [
    'allow_user_info_change' => true,
  ],
  'dbr.html filter' => '', // Default function for default dbr.html cleanup
  'dbr.html: filter' => '', // Default function for default dbr.html: cleanup
  'proxy' => [], // for optional proxy parameters
  'curl' => [], // for optional proxy parameters (CURL_OPT => 'value')
  'baselanguage' =>  'en_US',
  'translate_window' =>  ['width' => 762, 'height' => 688],
  'db_connection' => [
    'translate_db_locale' =>  true, // Determines if locale is used in database operations
    'mysql_init' => [],
    'sql_server_init' => 'SET ANSI_WARNINGS OFF;SET ARITHABORT OFF;SET ANSI_NULLS ON;',
    'sqlsrv_server_init' => 'SET ANSI_WARNINGS OFF;SET ARITHABORT OFF;SET ANSI_NULLS OFF;',
    'sybase_init' => 'set arithignore off;set quoted_identifier off;',
    'sqlanywhere_init' => '',
    'show_verbose_error_messages_to_all_users' => false,
    'databases' => [], /* If SQL Editor opens up too slowly due to slow "show databases"-command in MySQL, define the databases here */
    'pooled_connections' => true, /* Connections are pooled, will improve with servers that have slow connections */
    'fix_sqlsrv_field_metadata' => false,
    'redirect_on_connection_failure' => null,
    'sqlsrv_connect_info' => [
      'MultipleActiveResultSets' => 0, // https://github.com/microsoft/msphpsql/issues/1218
      'TrustServerCertificate' => true // For Microsoft ODBC Driver 18
    ],
    'sqlsrv_use_utf8_string' => false, // Uses N'string' notation
    'disable_writes_to_db' => false
  ],
  'linked_report' => [
    'autoexecute_when_only_optional' => false,
    'strip_dbr_html_tags_from_links' => true,
  ],
  'active_directory_mydbr_groups' => 'myDBR Groups',
  'active_directory_mydbr_admin_group' => 'myDBR Admins',
  'active_directory_sync_users' => [],
  'active_directory_synconly_users' => [],
  'active_directory_recursive_user_groups' => true,
  'active_directory' => [
    'visible_name' => 'Primary',
    'mydbr_username' => '{sAMAccountName}',
    'options' => [],
    'extra_domains' => [],
    'organization_ext_id' => null,
  ],
  'ui' => [
    'admin' => [
      'menu_collapsed' => ['fileedit', 'license', 'templates']
    ],
    'rtl' => true,
    'rtl_languages' => ['he']
  ],
  'updater_users' => ['mydbr_updater'], // Usernames which can use HTTP basic access authentication to call myDBR update URL
  'license_users' => ['license_checker'], // Usernames which can use HTTP basic access authentication to call myDBR license server URL
  'license_server' => [
    'is_server' => false, // Will respond to license update queries
    'server_url' => null, // Define license server URL
    'custom_server' => false, // Use your own license server code
    'username' => 'license_checker', // Can override script's username
    'password' => null, // Can override script's password
    'host' => null, // Can override current username
    'timeout' => 20, // Call timeout
    'use_proxy_if_defined' => true, // Use proxy if defined
  ],
  'query_builder_widths' => ['db' => 194, 'table' => 194, 'column' => 373, 'selected' => 454],
  'graphviz_dpi' => 96,
  'graphviz' => ['command_path' => null],
  'summary_row' => [
    'aggregate_null' => '',
    'hide_prefix_when_empty' => true
  ],
  'export' => [
    'export_choises' => ['Excel', 'PDF', 'CSV', 'SQL'],
    'colwidth_css' => 6.01,
    'excel' => [
      'storage' => [
        'cache_storage' => 'memory', // memory / cache_to_phpTemp / cache_in_memory_serialized / cache_in_memory_gzip / cache_to_apc
        'cache_settings' => [
          'cache_to_phpTemp' => ['memoryCacheSize' => '10kb'],
          'cache_to_apc' => ['cacheTime' => 600],
          'cache_to_memcache' => [
            'memcacheServer'  => 'localhost',
            'memcachePort'    => 11211,
            'cacheTime'       => 600
          ],
          'cache_to_wincache' => ['cacheTime' => 600],
        ],
        'lines_after_title' => 1,
      ],
      'type' => 'xlsx', // xls or xlsx as a default output format
      'line_height' => 12.75,
      'font_width' => 8.2,
      'include_image' => true,
      'utf8_replace' => [],
      'evaluate_formulas' => false,
      'aggregate_formula' => true,
      'user_styles' => [],
      'style' => [
        'header' => [
          'border' => [
            'style' => 'thin',
            'color' => ['rgb' => 'ff6600']
          ],
        ],
        'header_top' => [
          'borders' => [
            'top' => [
              'style' => 'medium',
              'color' => ['rgb' => 'ff6600']
            ]
          ],
        ],
        'header_basic' => [
          'borders' => [
            'top' => [
              'style' => 'medium',
              'color' => ['rgb' => 'ff6600']
            ],
            'bottom' => [
              'style' => 'thin',
              'color' => ['rgb' => 'ff6600']
            ],
          ],
          'font' => ['bold' => true],
        ],
        'title' => ['font' => ['bold' => true]],
        'subtitle' => ['font' => ['bold' => true]],
        'tabtitle' => ['font' => ['bold' => true]],
        'subtotal' => [
          'font' => ['italic' => true],
          'fill' => [
            'type' => 'solid',
            'color' => ['rgb' => 'F0F0F0'],
          ],
          'borders' => [
            'top' => [
              'style' => 'thin',
              'color' => ['rgb' => '0091A5']
            ],
            'bottom' => [
              'style' => 'thin',
              'color' => ['rgb' => '0091A5']
            ],
          ],
        ],
        'footer' => [
          'font' => ['italic' => true],
          'borders' => [
            'top' => [
              'style' => 'thin',
              'color' => ['rgb' => 'AAAAAA']
            ],
            'bottom' => [
              'style' => 'medium',
              'color' => ['rgb' => '0091A5']
            ],
          ],
        ],
        'pageview' => [
          'fill' => [
            'type' => 'solid',
            'color' => ['rgb' => 'E0E0E0']
          ],
        ],
        'comment' => [
          'fill' => [
            'type' => 'solid',
            'color' => ['rgb' => 'FFFFCC']
          ],
        ],
        'cell' => '', // Performance issues with PHPExcel, use only if needed
      ],
    ],
    'csv' => [
      'delimiter' => ',',
      'decimal_point' => '.',
      'enclosure' => '"',
      'date_format' => 'Y-m-d', // See http://php.net/manual/en/function.date.php
      'time_format' => 'H:i:s',
      'charset' => 'utf-8', // utf-8, ISO-8859-1
      'line_ending' => "\n",
      'header' => true, // Output the resultset header?
      'enclose_string_with_leading_or_trailing_space' => true,
      'enclose_always' => false,
      'linefeed_between_resultsets' => true,
      'use_BOM_in_UTF' => true,
      'direct_mode' => false,
      'skip_formatting' => false
    ],
    'pdf' => [
      'font' => 'Arial',
      'font_size' => 9,
      'font_width' => 8.5, // Arial 10 default width. Increase this if your PDF output produces columns too narrow
      'column_width_divider' => 5.941,
      'logo' => '', // in user/images
      'logo_width' => 40,
      'image_scale' => 1.25,
      'export_as_png' => false,
      'svg_modifications' => [
        'chartdirector' => [
          ['from' => '/stroke-opacity/', 'to' => 'opacity'],
        ],
        'graphviz' => [
          ['from' => '/<\?xml.*\<svg/s', 'to' => '<svg']
        ]
      ],
      'default_engine' => 'wkhtmltopdf'
    ],
    'wkhtmltopdf' => [
      'command' => 'wkhtmltopdf',
      'command_check' => null, /* If you override the command with your own script */
      'use_as_default' => true,
      'tmp_directory' => null,
      'clean_tmp_file_in_case_of_error' => true,
      'show_failed_command_to_all' => false,
      'remind_missing' => true,
      'options' => [
        'margin-top' => '--margin-top "20"',
        'header-spacing' => '--header-spacing "8"',
        'enable-local-file-access' => '--enable-local-file-access'
      ],
      'ie_content_disposition' => 'inline',
      'fix_wkhtmltopdf_input_submit_bug' => true,
      'skip_version_check' => null
    ],
    'weasyprint' => [
      'command' => 'weasyprint',
      'command_check' => null, /* If you override the command with your own script */
      'tmp_directory' => null,
      'clean_tmp_file_in_case_of_error' => true,
      'show_failed_command_to_all' => false,
      'remind_missing' => false,
      'ie_content_disposition' => 'inline',
      'skip_version_check' => null
    ],
    'json' =>  [
      'force_object' => false
    ],
    'sql' => [
      'is_admin_only' => true
    ],
    'xml' => ['compatibility_mode' => false],
    'use_PCLZIP' => false,
    'new_window' => false,
  ],
  'favourites_enabled' => true,
  'mainview' => [
    'favourites_enabled' => true,
    'show_edit' => true,
    'show_code' => true,
    'show_delete' => true,
    'dashboard_on_all_folders' => true,
    'dashboard_on_folder' => [],
    'pdf_open_in_new_window' => false,
    'open_in_new_window' => [], // Report ID's
    'open_all_in_new_window' => false,
    'favourites_can_toggle' => false,
    'extensions' => [],
    'use_alternate' => false,
    'cache_alternate' => true,
    'alternate_mainview_dispatcher_proc' => 'sp_mydbr_mainview_proc_get'
  ],
  'sql_editor' => [
    'show_query_builder_when_new' => false,
    'lines_when_to_use_dashes_in_comment' => 4,
    'max_saved' => ['proc' => 10, 'cmd' => 10],
    'autocomplete_mydbr' => true,
    'autocomplete_db' => [],
    'save_to_statistics' => false
  ],
  'file_manager' => [
    'chmod' => 0644
  ],
  'formatting' => [
    'float_decimals' => 2
  ],
  'php_loader' => [
    'ioncube' => ['recommended_version' => '12.0.2'],
    'sourceguardian' => ['recommended_version' => '14.0.0']
  ],
  'param_inline_pairs' => ['inStartDate' => 'inEndDate', 'dtFrom' => 'dtTo'],
  'permissions' => [
    'grant_all_disable' => false,
    'grant_direct_disable' => false
  ],
  'notifications' => [ // if missing features are reminded of
    'chartdirector_missing' => 1,
    'chartdirector_not_default' => 1,
    'chartdirector_needs_update' => 1,
    'wkhtml_missing' => 1,
    'new_version_is_for_admin_only' => false,
    'php_version_is_for_admin_only' => true,
    'php_loader' => true,
    'zip_missing' => 1,
    'dba_default_password' => true
  ],
  'error_reporting' => E_ALL & ~E_NOTICE & ~E_STRICT  & ~E_DEPRECATED,
  'logout' => [
    'url_redirect' => null,
    'url' => 'thankyou.html',
    'link_text' => '#{MYDBR_AMAIN_LOGOUT}',
    'allowed_redirect_urls_in_url_parameter' => ['']
  ],
  'google_maps_api_key_use_in_geocode' => true,
  'google_maps_api_key' => '',
  'cookie' => [
    'host' => null,
    'secure' => true,
    'samesite' => 'Lax',
    'samesite_secure' => null,
    'https_http_separate_cookie' => true,
    'httponly' => true,
    'ad_domain_days' => 30,
    'remember_me_days' => 30
  ],
  'openstreetmap' => [
    'geocode' => 'https://nominatim.openstreetmap.org/search?format=json&q=',
    'osm_node_geocode' => 'https://nominatim.openstreetmap.org/lookup?format=json&osm_ids='
  ],
  'geocode' => [
    'cache' => true
  ],
  'stickyheader' => true,
  'datetimefilter' => true,
  'datepicker' => ['showOn' => 'both'],
  'IE_override_compatibility_view' => true,
  'single_sign_on' => [
    'url_parameter' => 'url',
    'allow_admin' => true,
    'debug_failed_login' => false,
    'google' => [
      'client_id' => null, // OAuth 2.0 client IDs in https://console.developers.google.com/
      'client_secret' => null, // https://console.developers.google.com/
      'redirect_uri' => null, // Define if google rejects your redirect uri
      'mydbr_url' => null, // Define if not based on your myDBR installation
      'show_local_login' => false, // Define if not based on your myDBR installation
      'prompt' => 'select_account',
      'hosted_domain' => null // Restrict login to your domain
    ],
    'login_procedure' => null, // A procedure to be executed when SSO user logs in (allows to use automatic parameters)
  ],
  'remote_server' => ['timeout' => 60, 'skip_ssl_verify' => false],
  'template' => ['class' => 'template'],
  'date_time_formats' => [
    'fi_fi' => ['d' => 'd.m.Y', 't' => 'H.i.s'],
    'de_de' => ['d' => 'd.m.Y', 't' => 'H:i:s'],
    'en_us' => ['d' => 'Y-m-d', 't' => 'h:i:s a'],
    'es_es' => ['d' => 'd/m/Y', 't' => 'H.i.s'],
    'it_it' => ['d' => 'd/m/Y', 't' => 'H.i.s'],
    'nl_nl' => ['d' => 'd-m-Y', 't' => 'H.i.s'],
    'sv_se' => ['d' => 'Y-m-d', 't' => 'H:i:s']
  ],
  'connected_parameters' => ['show_empty_queries' => false],
  'login' => [
    'autocomplete' => 'on',
    'use_salted_hash' => true,
    'regenerate_session_id' => false,
    'skip_demo_url' => [],
    'show_session_expiration_notice' => false,
    'custom_session_expiration_notice' => ''
  ],
  'tablesorter' => [
    'default_sorting' => 'intelligent'
  ], /* intelligent/asc/desc */
  'show_main_without_login' => [
    'enabled' => false,
    'show_login_link' => false
  ],
  'scrollcheckbox' => ['lang' => ['de', 'es', 'fi', 'it', 'nl', 'sv', 'el']],
  'admin_restrictions' => [
    'restricted_actions' => [],
    'can_access_php' => true,
    'limited_admins' => [], /* Restrictions apply to these usernames */
    'full_admins' => [] /* No limitations to these usernames */
  ],
  'elevated_users'  => [],
  'lfcr_post' => [
    'chr' => [chr(10), chr(13)],
    'coded' => ['#0A', '#0D'],
    'to' => ['_ x*_LF_*x_', '_ x*_CR_*x_']
  ],
  'tooltip' => [
    'last' => '<div class="tt_all"><div class="tt_value">%2$s</div><hr>%1$s</div>',
    'floatingbox' => '<div class="tt_all"><div class="tt_value">[%3$s] - [%4$s]</div><hr>[%1$s] / [%2$s]</div>',
  ],
  'crosstab' => ['tooltip' => true],
  'password_reset' => [
    'from' => [
      'email' => null,
      'name' => null
    ],
    'replyto' => [
      'email' => null,
      'name' => null
    ],
    'debug' => 0
  ],
  'mail' => [
    'sleep_after_rows'  => 50,
    'sleep_microsec'    => 1000000, // microseconds
    'debug'             => 0,
    'notify_successful_mail' => 1,
    'keep_session' => false,
    'postprocess_cmd' => 'pandoc',
    'replace_from_record' => [  /* Outlook uses Word HTML parser which does not support multiple css classes -> fixing it */
      'from' => [
        'class="cell align_l',
        'class="cell align_r',
        'class="cell_header align_l',
        'class="cell_header align_r'
      ],
      'to' => [
        'class="cell_left align_l',
        'class="cell_right align_r',
        'class="cell_header_left align_l',
        'class="cell_header_right align_r'
      ]
    ]
  ],
  'https' => [
    'https_in_use' => null, // If server does not use $_SERVER['https'] and you still use https, set this flag to true to force https.
    'HTTP_X_FORWARDED_PROTO' => true,  // use HTTP_X_FORWARDED_PROTO? This is in AWS
  ],
  'header_cache' => [
    'Expires: Mon, 14 Oct 2002 05:00:00 GMT',              // Date in the past
    'Last-Modified: ' . gmdate("D, d M Y H:i:s") . ' GMT', // always modified
    'Cache-Control: no-store, no-cache, must-revalidate',  // HTTP 1.1
    'Cache-Control: post-check=0, pre-check=0',
    'Pragma: no-cache',                                    // HTTP 1.0
    // 'X-Frame-Options: SAMEORIGIN'
  ],
  'statistics' => [
    'enabled' => true,
    'start' => 'sp_MyDBR_Stat_AddStart', // If changed, check sp_MyDBR_Stat_AddStart for parameters
    'end' => 'sp_MyDBR_Stat_AddEnd',
    'include_cache_param_to_user_defined_end_call' => false // Do not break user defined statistics reports from pre 6.1.
  ],
  'date_range' => [
    'MYDBR_PARAM_DATE_RANGE_SELECT' => 'none',
    'MYDBR_PARAM_DATE_RANGE_TODAY' => ['from' => ['value' => 0, 'type' => 'day'], 'to' => ['value' => 0, 'type' => 'day']],
    'MYDBR_PARAM_DATE_RANGE_YESTERDAY' => ['from' => ['value' => -1, 'type' => 'day'], 'to' => ['value' => -1, 'type' => 'day']],
    'MYDBR_PARAM_DATE_RANGE_1WEEK' => ['from' => ['value' => -6, 'type' => 'day'], 'to' => ['value' => 0, 'type' => 'day']],
    'MYDBR_PARAM_DATE_RANGE_2WEEKS' => ['from' => ['value' => -13, 'type' => 'day'], 'to' => ['value' => 0, 'type' => 'day']],
    'MYDBR_PARAM_DATE_RANGE_THISWEEK' => ['from' => ['value' => 0, 'type' => 'week'], 'to' => ['value' => null, 'type' => 'week']],
    'MYDBR_PARAM_DATE_RANGE_LASTWEEK' => ['from' => ['value' => -1, 'type' => 'week'], 'to' => ['value' => -1, 'type' => 'week']],
    'MYDBR_PARAM_DATE_RANGE_THISMONTH' => ['from' => ['value' => 0, 'type' => 'month'], 'to' => ['value' => null, 'type' => 'month']],
    'MYDBR_PARAM_DATE_RANGE_LASTMONTH' => ['from' => ['value' => -1, 'type' => 'month'], 'to' => ['value' => -1, 'type' => 'month']],
    'MYDBR_PARAM_DATE_RANGE_1MONTH' => ['from' => ['value' => -1, 'type' => 'month'], 'to' => ['value' => 0, 'type' => 'month']],
    'MYDBR_PARAM_DATE_RANGE_2MONTHS' => ['from' => ['value' => -2, 'type' => 'month'], 'to' => ['value' => 0, 'type' => 'month']],
    'MYDBR_PARAM_DATE_RANGE_3MONTHS' => ['from' => ['value' => -3, 'type' => 'month'], 'to' => ['value' => 0, 'type' => 'month']],
    'MYDBR_PARAM_DATE_RANGE_6MONTHS' => ['from' => ['value' => -6, 'type' => 'month'], 'to' => ['value' => 0, 'type' => 'month']],
    'MYDBR_PARAM_DATE_RANGE_QUARTER' => ['from' => ['value' => 0, 'type' => 'quarter'], 'to' => ['value' => null, 'type' => 'quarter']],
    'MYDBR_PARAM_DATE_RANGE_PREVIOUSQUARTER' => ['from' => ['value' => -1, 'type' => 'quarter'], 'to' => ['value' => -1, 'type' => 'quarter']],
    'MYDBR_PARAM_DATE_RANGE_YEARTODAY' => ['from' => ['value' => 0, 'type' => 'year'], 'to' => ['value' => 0, 'type' => 'month']],
    'MYDBR_PARAM_DATE_RANGE_THISYEAR' => ['from' => ['value' => -1, 'type' => 'year'], 'to' => ['value' => null, 'type' => 'year']],
    'MYDBR_PARAM_DATE_RANGE_LASTYEAR' => ['from' => ['value' => -1, 'type' => 'year'], 'to' => ['value' => -1, 'type' => 'year']],
    'MYDBR_PARAM_DATE_RANGE_YEAR' => ['from' => ['value' => -1, 'type' => 'year'], 'to' => ['value' => 0, 'type' => 'year']],
    'MYDBR_PARAM_DATE_RANGE_2YEARS' => ['from' => ['value' => -2, 'type' => 'year'], 'to' => ['value' => 0, 'type' => 'year']],
    'MYDBR_PARAM_DATE_RANGE_3YEARS' => ['from' => ['value' => -3, 'type' => 'year'], 'to' => ['value' => 0, 'type' => 'year']],
  ],
  'upload' => [
    'excluded_files' => ['php', 'php3', 'php4', 'phtml', 'phps']
  ],
  'remote_files' => ['export_header_pdf.php'],
  'user_interface' => [
    'tablets_use_desktop_ui' => true,
    'force_mobile' => '',
    'force_desktop' => '',
  ],
  'sync' => [
    'folder' => 'myDBR Sync',
    'delimiter' => ':::',
  ],
  'hashing_algorithm' => [
    'sso' => 'sha1',
    'automatic_parameter_session_id' => 'sha1',
    'default' => 'sha1'
  ],
  'server_error' => [
    'text' => '#{MYDBR_ERROR_USER_TEXT}',
    'text_with_optional_link' => ' #{MYDBR_ERROR_USER_OPTIONAL}',
    'admin_mail_address' => '', // Define this and user error messages will include a mailto link
    'mail_subject' => '#{MYDBR_ERROR_USER_MAIL_SUBJECT}',
    'show_full_error_message_to_non_admin' => false
  ],
  'sendfile' => [
    'method' => 'readfile', // readfile or x-sendfile
    'base_directory' => '' // Set this to base directory
  ],
  /* OEM license capability to change the report logo dynamically, see user/reportheader_image.php */
  'reportheader_logo' => [
    'enabled' => false,
    'param' => 'inLogin'
  ],
  'calendar' => [
    'options' => [
      'fixedWeekCount' => false,
      'weekNumbers' => true,
      'navLinks' => true,
      // 'columnFormat' => 'dddd', •
      'headerToolbar' => ['left' => 'prev,next today', 'center' => 'title', 'right' => 'dayGridMonth,timeGridWeek,timeGridDay,listWeek'],
      'displayEventEnd' => true,
      'eventDisplay' => 'block',
      'eventResizableFromStart' => true,
      'nowIndicator' => true,
    ],
    'default_class' => '', /* Empty for myDBR style, fullcalendar for default fullcalendar style */
    'description.hide' => false,
    'location.hide' => true,
    'url.hide' => true
  ],
  'browser' => [
    'max_length' => 2048,
    'number_of_rows' => 200,
    'default_db' => ''
  ],
  'extension_like' => [
    'code_editing' => [
      'name' => '#{MYDBR_EXT_LIKE_CODE_EDITING}',
      'delay_loading' => false,
      'js' => ['lib/external/codemirror/editor.js'],
      'css' => [['src' => 'lib/external/codemirror/editor.css']]
    ],
    'calendar' => [
      'name' => '#{MYDBR_EXT_LIKE_CALENDAR}',
      'delay_loading' => false,
      'js' => ['lib/external/calendar/index.global.min.js', 'lib/external/calendar/locales-all.min.js', 'lib/external/calendar/ics.min.js'],
      'css' => []
    ],
    'richtext' => [
      'name' => '#{MYDBR_EXT_LIKE_RICHTEXT}',
      'delay_loading' => false,
      'js' => ['lib/external/tinymce/tinymce.min.js'],
      'css' => []
    ],
    'chartjs' => [
      'name' => 'Chart.js',
      'delay_loading' => true,
      'js' => [
        'lib/external/chartjs/chart.umd.js',
        'lib/external/chartjs/chartjs-plugin-datalabels.min.js',
        'lib/external/chartjs/chartjs_utils.js',
        'lib/external/chartjs/chartjs-adapter-date-fns.bundle.min.js'
      ],
      'css' => [],
      'rose' => ['opacity' => 0.4],
      'scatter' => ['opacity' => 0.7]
    ]
  ],
  'request' => ['ajax_only' => true],
  'extension_like_enabled' => [], // internal to myDBR
  'dbr_head' => ['enabled' => true],
  'nowrap_datatypes' => ['int', 'float', 'date'],
  'oem' => [
    'favicons' => [
      'favico' => null,
      'icons' => [[]] // entries array of: ('type': "image/png", 'href'="favicon-16x16.png", 'sizes'="16x16", 'rel' =>'icon') where rel and sizes are optional
    ],
    'main_tooltip' => '',
    'record_logins' => false // Deprecated, now in Environment settings
  ],
  'ip2location' => [
    'default_service_provider' => '', // maxmind, ip2location, or ipinfo
    'maxmind' => [
      'account_id' => 'ACCOUNT_ID',
      'license_key' => 'LICENSE_KEY'
    ],
    'ip2location' => [
      'api_key' => 'LICENSE_KEY',
      'package' => 'WS6'
    ],
    'ipinfo' => [
      'token' => 'TOKEN'
    ]
  ],
  'app_locale' => 'en_US.UTF-8',
  '2fa' => [
    'time_discrepancy' => 2, // In 30 intervals
    'only_for_external_ip' => false, // Enabled only for external ip
    'only_for_admin' => false // Enabled only for admin
  ],
  'mysql_no_information_schema_parameter' => true,
  'settings' => [
    'require_url_seed_value' => true
  ],
  'copy_to_clipboard' => ['decimal_separator' => null],
  'query_cache' => [
    'serializer' => 'json',
    'debug' => false,
    'show_redis_errors_to_users' => false
  ],
  'form_extension' => [
    'json_parameter_name' => 'inJSON'
  ],
  'webauthn' => [
    'active' => true
  ],
  'json_colstyle' => 'white-space:pre;font-family:ui-monospace',
];

// User's definitions for $mydbr_defaults. Do not include the user/defaults.php in case of an error in the user edited script
if (!(isset($_SERVER['SCRIPT_NAME']) && basename($_SERVER['SCRIPT_NAME']) == 'fileedit_v.php' &&
  isset($_POST['action']) && $_POST['action'] == 'save_file')) {
  require_once(dirname(__FILE__) . '/user/defaults.php');
}
