$( document ).ready(function() {
  $('.form-checkbox-item .form-dropdown,.form-checkbox-item .form-textbox, .form-radio-item .form-dropdown,.form-radio-item .form-textbox').removeAttr('required');
  var i, langs, l = $('input[name=lang] ').val(), select = 'select[id=lang] option';
  // URL does not have the lang-parameter
  if (l==undefined || l=='' || l == '{#lang}') {
    let multilang = {
      sv: 'sv_SE', 
      el: 'el_GR', 
      de: 'de_DE', 
      es: 'es_ES', 
      nl: 'nl_NL', 
      it: 'it_IT',
      fi: 'fi_FI'
    };
    // Default to lang set in myDBR, if that is not set use en_US
    l = (mydbr_sorting.lang!=='' && multilang[mydbr_sorting.lang]!==undefined)  ? multilang[mydbr_sorting.lang] : 'en_US';
  }
  langs = $.map($(select), e => $(e).val());
  i = langs.indexOf(l);
  if ($('select[id=lang]').length>0) {
    $('select[id=lang]')[0].value = ((i<0) ? 'en_US' : langs[i]);
    $('select[id=lang]').change( function() {
      var url = new URL(window.location.href);
      var search_params = url.searchParams;
      search_params.set('lang', $(this).val());
      url.search = search_params.toString();
      window.location.replace(url.toString());
    });
  }
  $('input.form-radio, input.form-checkbox').change(function( event ) {    
    $(this).closest('form').find('[name="'+$(this).attr('name')+'"]').each( function() {
      var s = $(this).siblings('[data-required="required"]');
      if (s.length>0) {
        s.prop('required', $(this).is(':checked'));
      }
    })
  });
  // Save form values and restore them when user changes the language
  // Form is saved to useer's sessionStorage with id of form id + report id
  var form_id = $('form[data-formext="1"]').attr('id');
  var urlParams = new URLSearchParams(window.location.search);
  var r = urlParams.get('r')
  var $form = $("#"+form_id), formSave = new FormStorage(form_id+r);
  formSave.restore($form);
  window.onbeforeunload = function () {
    formSave.preserve($form);
  }
  $form.submit(function (e) {
    if ($(this).data('json')!==undefined) {
      var formData= new FormData(this)
      var json = JSON.stringify(Object.fromEntries(formData));
      var param_name = $(this).data('jsonparam');
      $(this).html('<input type="hidden" name="'+param_name+'">');
      $(this).find('input').val(json);
    }
    formSave.remove($form);
  });
});
