<?php

/**
 * Creates a iCalendar (ics) file
 *
 * @param string $id
 * @param array $options
 * @param string $dataIn
 * @param string $colInfo
 * @return void
 */
function Ext_iCalendar( $id, $options,  $dataIn, $colInfo )
{
  require_once('zapcallib.php');
  
  $icalobj = new ZCiCal();

  foreach ($dataIn as $eventdata) {
    $eventobj = new ZCiCalNode("VEVENT", $icalobj->curnode);
    $eventobj->addNode(new ZCiCalDataNode("SUMMARY:" . $eventdata[2]));
    $eventobj->addNode(new ZCiCalDataNode("DTSTART:" . ZCiCal::fromSqlDateTime($eventdata[0])));
    $eventobj->addNode(new ZCiCalDataNode("DTEND:" . ZCiCal::fromSqlDateTime($eventdata[1])));
    $eventobj->addNode(new ZCiCalDataNode("UID:" . date('Y-m-d-H-i-s'). microtime() . "@".isset($_SERVER['SERVER_NAME']) ? $_SERVER['SERVER_NAME'] : 'mydbr'));
    $eventobj->addNode(new ZCiCalDataNode("DTSTAMP:" . ZCiCal::fromSqlDateTime()));
    $eventobj->addNode(new ZCiCalDataNode("Description:" . ZCiCal::formatContent( $eventdata[3])));
  }
  header('Content-type: text/calendar; charset=utf-8');
  $filename = isset($options['dbr.icalendar']['filename']) ? $options['dbr.icalendar']['filename'] : 'icalendar.ics';
  if (!_str_ends_with($filename, '.ics')) {
    $filename .= '.ics';
  }
  header('Content-Disposition: inline; filename='.$filename);
  echo $icalobj->export();  
  die();
}
