<?php

function Ext_OrgChart( $id, $options,  $dataIn, $colInfo )
{
  $chart_options = isset($options['dbr.org.chart']['options']) ? $options['dbr.org.chart']['options'] : '';

  if (sizeof($dataIn)==0) {
    return;
  }
  if (sizeof($dataIn[0])<4) {
    error_print('Check the data: select id, parent_id, position, label');
    return;
  }
  
  $box_width = 138;
  $box_height = 40;
  
  $tooltip_col = null;
  if (isset($options['dbr.org.chart.tooltip'])) {
    $tooltip_col = array_search($options['dbr.org.chart.tooltip']['column'], $colInfo['columnreference']);
    if ($tooltip_col===false) {
      $tooltip_col = null;
    }
  }
  $drop_procedure = '';
  $drop_hash = '';
  $drop_can_procedure = '';
  $drop_can_hash = '';
  $drop_callback = '';
  if (isset($options['dbr.org.chart.drop'])) {
    list($drop_procedure, $drop_hash) = Extension::procedureToId($options['dbr.org.chart.drop']['procedure']);
    if (isset($options['dbr.org.chart.drop']['can_drop_procedure'])) {
      list($drop_can_procedure, $drop_can_hash) = Extension::procedureToId($options['dbr.org.chart.drop']['can_drop_procedure']);
    }
    if (isset($options['dbr.org.chart.drop']['callback'])) {
      $drop_callback = $options['dbr.org.chart.drop']['callback'];
    }
  }
  $move_procedure = '';
  $move_hash = '';
  $move_can_procedure = '';
  $move_can_hash = '';
  $move_procedure = '';
  $move_hash = '';
  $move_callback = '';
  if (isset($options['dbr.org.chart.move'])) {
    list($move_procedure, $move_hash) = Extension::procedureToId($options['dbr.org.chart.move']['procedure']);
    if (isset($options['dbr.org.chart.move']['can_move_procedure'])) {
      list($move_can_procedure, $move_can_hash) = Extension::procedureToId($options['dbr.org.chart.move']['can_move_procedure']);
    }
    if (isset($options['dbr.org.chart.move']['callback'])) {
      $move_callback = $options['dbr.org.chart.move']['callback'];
    }
    
    $drop_procedure = '';
    $drop_hash = '';
    $drop_can_procedure = '';
    $drop_can_hash = '';
  }
  $hSpace = null;
  if (isset($options['dbr.org.chart.nodehspace'])) {
    $hSpace = $options['dbr.org.chart.nodehspace']['space'];
  }
  $vSpace = null;
  if (isset($options['dbr.org.chart.nodevspace'])) {
    $vSpace = $options['dbr.org.chart.nodevspace']['space'];
  }
  $hShift = null;
  if (isset($options['dbr.org.chart.nodehshift'])) {
    $hShift = $options['dbr.org.chart.nodehshift']['space'];
  }
  if (isset($options['dbr.org.chart.nodesize'])) {
    $box_width = $options['dbr.org.chart.nodesize']['width']-2;
    $box_height = $options['dbr.org.chart.nodesize']['height']-2;
  }
  $animate = null;
  if (isset($options['dbr.org.chart.animate']) && !isset($_GET['export'])) {
    $animate = intval($options['dbr.org.chart.animate']['animate']);
  }
  $toggle = null;
  $toggle_procedure = '';
  $toggle_hash = '';
  if (isset($options['dbr.org.chart.toggle']) && !isset($_GET['export'])) {
    $t = $options['dbr.org.chart.toggle']['toggle'];
    if ($t == '0' || (is_int($t) && $t == 0)) {
      $toggle = 0;
    } else {
      $toggle = 1;
    }
    if ($toggle) {
      if ($t !== '0' && $t !== '1' && !is_int($t)) {
        list($toggle_procedure, $toggle_hash) = Extension::procedureToId($t);
      }
    }
  }
  $autobalance = '';
  if (isset($options['dbr.org.chart.autobalance'])) {
    $autobalance = $options['dbr.org.chart.autobalance']['autobalance'];
  }
  if ($opt_o = json_decode((string) $chart_options)) {
    if (property_exists($opt_o, 'boxHeight')) {
      $box_height = $opt_o->boxHeight;
    } else {
      $opt_o->boxHeight = $box_height;
    }
    if (property_exists($opt_o, 'boxWidth')) {
      $box_width = $opt_o->boxWidth-2;
    } else {
      $opt_o->boxWidth = $box_width;
    }
  } else {
    $opt_o = array();
    if (!is_null($animate)) {
      $opt_o['animate'] = $animate;
    }
    if (!is_null($toggle)) {
      $opt_o['toggle'] = $toggle;
    }
    if ($toggle_procedure) {
      $opt_o['toggle'] = 1;
      $opt_o['toggle_procedure'] = $toggle_procedure;
      $opt_o['toggle_hash'] = $toggle_hash;
    }
    $opt_o['boxHeight'] = intval($box_height);
    $opt_o['boxWidth'] = intval($box_width);
    if (!is_null($hSpace)) {
      $opt_o['hSpace'] = intval($hSpace);
    }
    if (!is_null($vSpace)) {
      $opt_o['vSpace'] = intval($vSpace);
    }
    if (!is_null($hShift)) {
      $opt_o['hShift'] = intval($hShift);
    }
  }
  if ($autobalance) {
    $opt_o['autobalance'] = $autobalance;
  }
  $chart_options = json_encode($opt_o);
  /* This will add a drill menu in cases where multiple linked reports need a menu */
  Extension::add_drill_menu();

  $obj_id = 'org_chart'.$id;
  $canvas_id = 'org_chart_canvas'.$id;
  
  if ($move_procedure) {
    $move = ' data-drop='.pl_attr($move_procedure).' data-droph='.pl_attr($move_hash);
    if ($move_can_procedure) {
      $move .= ' data-drop-can='.pl_attr($move_can_procedure).' data-droph-can='.pl_attr($move_can_hash);
    }
    if ($move_callback) {
      $move .= ' data-dropcb='.pl_attr($move_callback);
    }
  } else {
    $move = '';
  }
  if ($drop_procedure) {
    $drop = ' data-drop='.pl_attr($drop_procedure).' data-droph='.pl_attr($drop_hash);
    if ($drop_can_procedure) {
      $drop .= ' data-drop-can='.pl_attr($drop_can_procedure).' data-droph-can='.pl_attr($drop_can_hash);
    }
    if ($drop_callback) {
      $drop .= ' data-dropcb='.pl_attr($drop_callback);
    }
  } else {
    $drop = '';
  }

  echo '<style>#'.$canvas_id.' .n { width:'.$box_width.'px;height: '.$box_height.'px}</style>';
  echo '<div class="organization_wrapper">'.
    '<div class="organization_target_tt"></div>'.
    '<div id="'.$canvas_id.'" data-object='.pl_attr($obj_id).' '.Extension::resultclass(true, 'organization_chart', true).$move.$drop.'></div>';
  
    // IE does not support ES6 (Edge does)
  $nodeclass_col = null;
  
  if (isset($options['dbr.org.chart.nodeclass']['column'])) {
    $nodeclass_col = array_search($options['dbr.org.chart.nodeclass']['column'], $colInfo['columnreference']);
    if ($nodeclass_col===false) {
      $nodeclass_col= null;
    }
  }
  $nodetoggle_col = null;
  if (isset($options['dbr.org.chart.nodetoggle']['column'])) {
    $nodetoggle_col = array_search($options['dbr.org.chart.nodetoggle']['column'], $colInfo['columnreference']);
    if ($nodetoggle_col===false) {
      $nodetoggle_col = null;
    }
  }
  $nodewidth_col = null;
  if (isset($options['dbr.org.chart.nodewidth']['column'])) {
    $nodewidth_col = array_search($options['dbr.org.chart.nodewidth']['column'], $colInfo['columnreference']);
    if ($nodewidth_col===false) {
      $nodewidth_col = null;
    }
  }
  $nodeheight_col = null;
  if (isset($options['dbr.org.chart.nodeheight']['column'])) {
    $nodeheight_col = array_search($options['dbr.org.chart.nodeheight']['column'], $colInfo['columnreference']);
    if ($nodeheight_col===false) {
      $nodeheight_col = null;
    }
  }
  $lineclass_col = null;
  if (isset($options['dbr.org.chart.lineclass']['column'])) {
    $lineclass_col = array_search($options['dbr.org.chart.lineclass']['column'], $colInfo['columnreference']);
    if ($lineclass_col===false) {
      $lineclass_col = null;
    }
  }
  echo '</div>'.
    '<script>'."\n".'var '.$obj_id.' = new OrganizationChart('.$chart_options.');'."\n";
  
  for ($row=0; $row < sizeof($dataIn); $row++) {
    $url = '';
    if ($urls  = Extension::get_report_links_direct($id, $obj_id, $dataIn[$row], false)) {
      $url = $urls;
    }
    $nodeclass = '';
    if (!is_null($nodeclass_col)) {
      $nodeclass = $dataIn[$row][$nodeclass_col];
    }
    $nodetoggle = '';
    if (!is_null($nodetoggle_col)) {
      $nodetoggle = $dataIn[$row][$nodetoggle_col];
    }
    $nodewidth = null;
    if (!is_null($nodewidth_col)) {
      $nodewidth = $dataIn[$row][$nodewidth_col];
    }
    $nodeheight = null;
    if (!is_null($nodeheight_col)) {
      $nodeheight = $dataIn[$row][$nodeheight_col];
    }
    $lineclass = null;
    if (!is_null($lineclass_col)) {
      $lineclass = $dataIn[$row][$lineclass_col];
    }
    $tooltip_data = null;
    if (!is_null($tooltip_col)) {
      $tooltip_data = $dataIn[$row][$tooltip_col];
      $nodeclass .= ' tTip';
    }
    
    
    list($node_id, $parent_id, $direction, $name ) = array_slice($dataIn[$row], 0, 4);
    echo $obj_id.'.addNode('.
      json_encode($node_id). ','.
      (is_null($parent_id) ? "''" : json_encode($parent_id)). ','.
      json_encode($direction).",".
      json_encode($name).",".
      ($nodeclass ? json_encode($nodeclass) : '""').",".
      (_str_starts_with($url, "{") && _str_ends_with($url, "}") ? $url : '"'.$url.'"').",".
      ($nodetoggle ? json_encode($nodetoggle) : '""').",".
      (!is_null($nodewidth) ? intval($nodewidth) : 'null').",".
      (!is_null($nodeheight) ? intval($nodeheight) : 'null').",".
      (!is_null($lineclass) ? json_encode($lineclass) : '""').",".
      ($tooltip_data ? json_encode(htmlspecialchars($tooltip_data)) : '""').",".
      json_encode(Extension::get_hash($node_id)).
      ");\n";
  }

  $scores = array();
  if (isset($options['dbr.org.target'])) {
    $target = $options['dbr.org.target'];
    for ($i=0; $i < (is_array($target['node_id']) ? sizeof($target['node_id']) : (isset($target['node_id']) ? 1 : 0)) ; $i++) {
      if ( !is_array($target['node_id'])) {
        $node_id = $target['node_id'];
        $weight = $target['weight'];
        $score = is_null($target['score']) ? '0': $target['score'];
        $color = $target['color'];
        $name = $target['name'];
      } else {
        $node_id = $target['node_id'][$i];
        $weight = $target['weight'][$i];
        $score = isset($target['score'][$i]) ? $target['score'][$i] : '0';
        $color = $target['color'][$i];
        $name = $target['name'][$i];
      }
      echo $obj_id.'.addColorBox('.json_encode($node_id).','.$weight.','.$score.',"'.$color.'",'.json_encode($name).');'."\n";
    }
  }
  echo '$(document).ready(function() {'.
    $obj_id.'.drawChart("'.$canvas_id.'", "", false);'."\n".
    $obj_id.'.drawColorBox();'."\n";
  if ($move_procedure) {
    echo  $obj_id.'.dragAndDrop();'."\n";
  }
  if ($drop_procedure) {
    echo  $obj_id.'.drop();'."\n";
  }
  echo '$("#'.$canvas_id.' .tTip").tipTip({defaultPosition:"top",maxWidth:"auto"});'.
    '});';
  echo '</script>';
}
