<?php

global $ini_file, $thread_safe, $os, $compiler;

function uname($part = 'a')
{
    $result = '';
    if (true) {
        $result = @php_uname($part);
    } elseif (function_exists('posix_uname') && !function_is_disabled('posix_uname')) {
        $posix_equivs = array(
                     'm' => 'machine',
                     'n' => 'nodename',
                     'r' => 'release',
                     's' => 'sysname'
                 );
        $puname = @posix_uname();
        if ($part == 'a' || !array_key_exists($part,$posix_equivs)) {
           $result = join(' ',$puname);
        } else {
           $result = $puname[$posix_equivs[$part]];
        }
    } else {
        if (!function_is_disabled('phpinfo')) {
            ob_start();
            phpinfo(INFO_GENERAL);
            $pinfo = ob_get_contents();
            ob_end_clean();
            if (preg_match('~System.*?(</B></td><TD ALIGN="left">| => |v">)([^<]*)~i',$pinfo,$match)) {
                $uname = $match[2];
                if ($part == 'r') {
                    if (!empty($uname) && preg_match('/\S+\s+\S+\s+([0-9.]+)/',$uname,$matchver)) {
                        $result = $matchver[1];
                    } else {
                        $result = '';
                    }
                } else {
                    $result = $uname;
                }
            }
        } else {
            $result = '';
        }
    }
    return $result;
}

function get_zip_links()
{
  global $thread_safe, $os, $compiler;

  $arch = uname('m');

  $os = strtolower(substr(uname('s'),0,3));
  if ($os=='dar' && !preg_match( '/arm64/', $arch)) $os='mac';
  if ( !in_array( $os, array( 'mac', 'dar', 'lin', 'win', 'sun', 'ope', 'fre' )) )
    return '';

  $name = 'http://downloads2.ioncube.com/loader_downloads/ioncube_loaders_' . $os . '_';
  if ($os=='win') {
    if (!$thread_safe )
      $name .= 'nonts_';
    $name .= strtolower($compiler).'_';
  }
  if ( !preg_match( '/86/', $arch ))
  {
    if ( preg_match( '/arm64/', $arch )) {
      $name .= 'arm64';
    } else {
      return '';
    }
  } else {
    $name .= 'x86';
  }
  if ($os!='win' && !preg_match( '/arm64/', $arch )) {
    $wordsize = ((-1^0xffffffff) ? 64 : 32);
    if ($wordsize == 64) {
      $name .= '-64';
    }
  }

  $link = 'Download the latest loader installation package for ';
  switch ($os)
  {
    case 'sun':
      $link .= '<a href="' . $name . '.zip">Solaris</a>';
      break;

    case 'ope':
      $link .= '<a href="' . $name . '.zip">OpenBSD</a>';
      break;

    case 'fre':
      $link .= '<a href="' . $name . '.zip">FreeBSD</a>';
      break;

    case 'win':
      $link .= '<a href="' . $name . '.zip">Windows</a>';
      break;

    case 'mac':
      $link .= '<a href="' . $name . '.zip">macOS</a>';
      break;

    case 'lin':
      $link .= '<a href="' . $name . '.zip">Linux</a>';
      break;

    default:
      $link = '';
  }
  if ( $link )
    $link = '<p>' . $link . '</p>';
  return $link;
}

function get_system_info()
{
  global $ini_file, $thread_safe, $compiler;

  $thread_safe = false;
  $compiler = (substr(PHP_OS, 0, 3) == 'WIN') ? 'VC6': '';
  ob_start();
  phpinfo(INFO_GENERAL);
  $php_info = ob_get_contents();
  ob_end_clean();

  $breaker = (php_sapi_name() == 'cli')?'\n':'</tr>';
  $lines = explode($breaker,(string) $php_info);

  foreach ($lines as $line) {
    if (preg_match('/thread safety/i', $line)) {
      $thread_safe = (preg_match('/(enabled|yes)/i', $line) != 0);
    }

    if (preg_match('~configuration file.*(</B></td><TD ALIGN="left">| => |v">)([^ <]*)~i',$line,$match)) {
      $ini_file = $match[2];

      if (!@file_exists($ini_file)) {
        $ini_file = '';
      }
    }
    if ($compiler && preg_match('/compiler/i',$line)) {
      $supported_match = 'VC6|VC9|VC11';
      $is_supported_compiler = preg_match("/($supported_match)/i",$line);
      if (preg_match("/(VC[0-9]+)/i",$line,$match)) {
        $compiler = strtoupper($match[1]);
      } else {
        $compiler = '';
      }
    }

  }
}

function ioncube_loader_version_information()
{
  if (extension_loaded('ionCube Loader')) {
    $old_version = true;
    $liv = "";
    $lv = "Unknown version";
    if (function_exists('ioncube_loader_iversion')) {
      $liv = ioncube_loader_iversion();
      $lv = sprintf("%d.%d.%d", $liv / 10000, ($liv / 100) % 100, $liv % 100);

    }
    return '<p class="topic" style="padding: 10px;color:green;">You have ionCube loader version '.$lv.' installed.<br>You may still want to check that you have the <a href="http://www.ioncube.com/loaders.php" target="_blank">latest version</a> installed.</p>';
  }
  return '';
}

get_system_info();
$download_link = get_zip_links();

if ($os=='win' &&  $thread_safe) {
  $loader_name = 'ioncube_loader_' . $os . '_' . substr(phpversion(),0,3) . ( ($os=='win') ? '.dll' : '.so' );
} else {
  $loader_name = 'ioncube_loader_' . $os . '_' . substr(phpversion(),0,3) .($thread_safe  ?'_ts' : '') . ( ($os=='win') ? '.dll' : '.so' );
}

$extension_dir = realpath( ini_get( 'extension_dir' ) );
if ( $extension_dir == '' )
  $extension_dir = '&lt;php extension dir&gt;';
else
  $extension_dir .= DIRECTORY_SEPARATOR;

if ( $ini_file == '' )
  $ini_file = '&lt;php.ini&gt;';

?><!DOCTYPE html>
<html>
<head>
  <title>myDBR Install</title>
  <link rel="stylesheet" href="install.css" type="text/css" media="screen" title="no title">
  <link rel="stylesheet" href="install/install.css" type="text/css" media="screen" title="no title">
  <!--[if IE]>
  <link href="ie.css" rel="stylesheet" type="text/css">
  <link href="install/ie.css" rel="stylesheet" type="text/css">
  <![endif]-->
</head>
<body>
<div id="header_noc">
  <div id="header_content" class="fixed">myDBR Installation - PHP Loader
  </div>
</div>

<div id="content" style="margin-top: 40px;">
  <p>
    Before you can start using myDBR, the ionCube Loader PHP extension needs to be installed on your server. myDBR is a compiled
    application that can only function with the ionCube loader installed.
  </p>
  <p>
    ionCube does provide an excellent <a href="http://www.ioncube.com/loaders.php" target="_blank" >Loader Wizard PHP script</a> which you can try if the instructions below do not work for you.
  </p>
  <p>
    The file that redirected to this page: <b><?php echo $_SERVER['SCRIPT_NAME'];  ?></b>
  </p>

  <?php echo ioncube_loader_version_information(); ?>
  <table class="install_tests" style="margin-top: 40px;">
    <tbody>
    <tr>
      <td class="topic">PHP info</td>
      <td class="todo" style="visibility: hidden">ToDo</td>
    <tr>
      <td class="details" colspan="2">
      <p>
      PHP version: <code class="inline"><?php echo phpversion(); ?></code><br>
      Thread Safety: <code class="inline"><?php echo $thread_safe ? 'Yes' : 'No'; ?></code><br>
      Extension Directory: <code class="inline"><?php echo $extension_dir?></code>
      </p>
      </td>
    </tr>
    <tr>
      <td class="topic">Download ionCube loader</td>
      <td class="todo">ToDo</td>
    </tr>
    <tr>
      <td class="details" colspan="2">
        <?php if ( $download_link == '' ) : ?>
          <p>Please go to <a href="http://www.ioncube.com/loaders.php" target="_blank" >ioncube.com</a> and download the
            loader appropriate for your server configuration.
          </p>
        <?php else :?>
          <?php echo get_zip_links() ?>
          <p>If the above link is incorrect, please visit <a href="http://www.ioncube.com/loaders.php" target="_blank">ioncube.com</a> for
            a complete list of loaders and download the package appropriate for your server configuration
          </p>
        <?php endif;?>
      </td>
    </tr>

    <tr>
      <td class="topic">Copy loader to the extension directory</td>
      <td class="todo">ToDo</td>
    </tr>

    <tr>
      <td class="details" colspan="2">
        <p>From the ionCube installation package copy the file
          <code class="line"><?php echo $loader_name ?></code> to directory <code class="line"><?php echo $extension_dir?></code></p>
      </td>
    </tr>

    <tr>
      <td class="topic">Add loader to php.ini</td>
      <td class="todo">ToDo</td>
    </tr>

    <tr>
      <td class="details" colspan="2">
        <p>Add the following line to <code class="line"><?php echo $ini_file?></code></p>
        <pre class="term">zend_extension<?php
          echo ($thread_safe && !version_compare(phpversion(), '5.3.0', 'ge') ? '_ts' : ''); ?> = <?php echo (($os=='win') ? '"' : '') . $extension_dir .  $loader_name .(($os=='win') ? '"' : '')?></pre>
      </td>
    </tr>

    <tr>
      <td class="topic">Restart your web server/PHP-FPM</td>
      <td class="todo">ToDo</td>
    </tr>

    <tr>
      <td class="details" colspan="2">
        <p>Finally, restart the web-server/PHP-FPM and reload this page.</p>
        <p>Please consult the ionCube installation guide for further information</p>
      </td>
    </tr>

    </tbody>
  </table>
  <div class="buttons">
    <a href="" class="button">Retry</a>
  </div>
</div>
</body>
</html>
<?php die(); ?>