var mydbr_chartjs = {
  value_formatter: function(value, ctx) {
    let mydbr = ctx.chart.config.options.mydbr;
    if (ctx.chart.options.plugins.labels.render=='percent') {
      if (ctx.chart.options.type=='bar' && ctx.chart.data.datasets.length>1) {
        let sum = 0;
        for (var i = 0; i < ctx.chart.data.datasets.length; i++) {
          let iv = ctx.chart.data.datasets[i].data[ctx.dataIndex];
          sum += isNaN(iv) ? 0 : iv;
        }
        let percentage = Math.round((value / sum) * 100) + '%';
        return percentage;
      }
      let dataset = ctx.chart.data.datasets[ctx.datasetIndex];
      let sum = dataset.data.reduce((a, b) => (isNaN(a) ? 0 : a) + (isNaN(b) ? 0 : b), 0);
      let percentage = Math.round((value / sum) * 100) + '%';
      return percentage;
    }
    if (Array.isArray(mydbr.labels) && mydbr.labels.length) {
      if (mydbr.labels.length > ctx.dataIndex) {
        return mydbr.labels[ctx.dataIndex];
      }
    }
    if (!Array.isArray(mydbr.labels)) {
      var r;
      if (mydbr.labelSwap) {
        r = mydbr.labels[mydbr.dataindexes[ctx.dataIndex]][mydbr.datasets[ctx.datasetIndex]];
      } else {
        r = mydbr.labels[mydbr.dataindexes[ctx.datasetIndex]][mydbr.datasets[ctx.dataIndex]];
      }
      if (r === undefined) {
        return '';
      }
      return r;
    } else {
      return '';
    }
  },
  chartjs_click: function(evt){ 
    var url, link, td, i, linkmenu = $(evt.target).attr('data-menu'), cjs = window[$(evt.target).attr('data-obj')],
      a =  cjs.getElementsAtEventForMode(evt, 'nearest', { intersect: true }, true), links, ds, ind;
      if (a.length==0) return;

    if (Object.keys(cjs.options.mydbr.url_keys).length) {
      var theChart = window['chart_js_'+evt.target.id];
      if (theChart.config.type=='scatter' || theChart.data.datasets[a[0].datasetIndex].type=='scatter') {
        /* Scatter */
        ds =theChart.data.datasets[a[0].datasetIndex].label;
        // Scatterline chart's line part
        if (theChart.data.datasets[a[0].datasetIndex].data[a[0].index].x==undefined) {
          ind = a[0].element.$context.parsed.x;
        } else {
        ind = theChart.data.datasets[a[0].datasetIndex].data[a[0].index].x;
        }
      } else {
        ds =theChart.data.labels[a[0].index];
        ind = theChart.data.datasets[a[0].datasetIndex].label;
      }
      
      links = cjs.options.mydbr.urls[ cjs.options.mydbr.url_keys[ds][ind]];
    } else {
      links = cjs.options.mydbr.urls[a[0].index];
    }
    if (links.length>1) {
      for (i=0; i < links.length; i++) { 
        td = $('#'+linkmenu+' td').eq(i);
        link = $("<a>");
        link.attr("href", links[i][1]);
        link.text(links[i][0]);
        if (links[i].target) {
          link.addClass(links[i].target);
        }
        td.html(link);
      }
      return !showPopup(linkmenu, evt, true);
    } else {
      url = links[0][1];
      if (url.startsWith("javascript")) {
        url = url.replace(/%25/g, '%');
        var F=new Function (url);
        F();
      } else {
        window.location = url;
      }
    }
  }
};

const getOrCreateTooltip = (chart) => {
  let tooltipEl = chart.canvas.parentNode.querySelector('div');

  if (!tooltipEl) {
    tooltipEl = document.createElement('div');
    tooltipEl.className = 'chartjs-tt';

    const table = document.createElement('table');

    tooltipEl.appendChild(table);
    chart.canvas.parentNode.appendChild(tooltipEl);
  }

  return tooltipEl;
};

const externalTooltipHandler = (context) => {
  // Tooltip Element
  const {chart, tooltip} = context;
  const tooltipEl = getOrCreateTooltip(chart);

  // Hide if no tooltip
  if (tooltip.opacity === 0) {
    tooltipEl.style.opacity = 0;
    return;
  }

  // Set Text
  if (tooltip.body) {
    const titleLines = tooltip.title || [];
    const bodyLines = tooltip.body.map(b => b.lines);

    const tableHead = document.createElement('thead');

    titleLines.forEach(title => {
      const tr = document.createElement('tr');
      tr.style.borderWidth = 0;

      if (context.chart.config.options.mydbr.tooltips === null) {
        const th = document.createElement('th');
        th.style.borderWidth = 0;
        const text = document.createTextNode(title);

        th.appendChild(text);
        tr.appendChild(th);
      }
      tableHead.appendChild(tr);
    });

    const tableBody = document.createElement('tbody');
    bodyLines.forEach((body, i) => {
      if (context.chart.config.options.mydbr.tooltips === null) {
        const colors = tooltip.labelColors[i];

        var span = document.createElement('span');
        span.style.background = colors.backgroundColor;
        span.style.borderColor = 'rgba(255, 255, 255, 0.4)';
        span.style.borderWidth = '1px';
        span.style.borderStyle = 'solid';
        span.style.marginRight = '10px';
        span.style.height = '10px';
        span.style.width = '10px';
        span.style.display = 'inline-block';
      }
      const tr = document.createElement('tr');
      tr.style.backgroundColor = 'inherit';
      tr.style.borderWidth = 0;

      const td = document.createElement('td');
      td.style.borderWidth = 0;

      if (context.chart.config.options.mydbr.tooltips === null) {
        const text = document.createTextNode(body);

        td.appendChild(span);
        td.appendChild(text);
      } else {
        const div = document.createElement('div');
        div.innerHTML = body;
        td.appendChild(div);
      }
      tr.appendChild(td);
      tableBody.appendChild(tr);
    });

    const tableRoot = tooltipEl.querySelector('table');

    // Remove old children
    while (tableRoot.firstChild) {
      tableRoot.firstChild.remove();
    }

    // Add new children
    tableRoot.appendChild(tableHead);
    tableRoot.appendChild(tableBody);
  }

  const {offsetLeft: positionX, offsetTop: positionY} = chart.canvas;

  // Display, position, and set styles for font
  tooltipEl.style.opacity = 1;
  tooltipEl.style.left = positionX + tooltip.caretX + 'px';
  tooltipEl.style.top = positionY + tooltip.caretY + 'px';
  tooltipEl.style.font = tooltip.options.bodyFont.string;
  tooltipEl.style.padding = tooltip.options.padding + 'px ' + tooltip.options.padding + 'px';
};