<?php
define( 'MYDBR_SECRET', 'secret');
define('HASHING_ALGORITHM', 'sha1');

// Use whatever require that is needed to get your app's session initialization routine visible
require_once( '../lib/utilities.php' );

// Start your apps session
start_session_in_my_app();

// If the user has not been logged into your app, redirect to your login
if (!isset($_SESSION['login_id'])) {
  header('Location:' . '../lib/login');
  die();
}

// Fill in the user info from your app's session. User groups and admin status can be set as well
$groups = '';
$admin = "0";
$user = $_SESSION['login_id'];
$name = $_SESSION['username'];
$email = $_SESSION['email'];;

// These come from mYDBR when myDBR notices the user has no session and asks user info from your app
$token = $_REQUEST['token'];
$url = $_REQUEST['url'];
$hash = $_REQUEST['hash'];

if ($hash!=hash(HASHING_ALGORITHM, $url.$token.MYDBR_SECRET)) {
  die('Unmatching hash value. The call did not come from myDBR');
}

$hash = sha1( $user . $name . $groups . $email . $admin .$token . MYDBR_SECRET );
  
$url = $url . '?user=' . urlencode((string) $user) . '&name=' . urlencode((string) $name) . '&hash=' . $hash .'&groups=' . urlencode((string) $groups) . 
  '&email=' . urlencode((string) $email) . '&admin=' . $admin;

header('Location:' . $url);
die();